<?
IncludeModuleLangFile(__FILE__);

use Bitrix\Main\Application;
use Bitrix\Main\Localization\Loc;
Loc::loadMessages(__FILE__);


Class cocount21187_cocount21187 extends CModule
{
	const MODULE_ID = 'cocount21187.cocount21187';
	var $MODULE_ID = 'cocount21187.cocount21187'; 
	var $MODULE_VERSION;
	var $MODULE_VERSION_DATE;
	var $MODULE_NAME;
	var $MODULE_DESCRIPTION;
	var $MODULE_CSS;
	var $strError = '';
	var $exclusionAdminFiles;

	function __construct()
	{
		$arModuleVersion = array();
		include(dirname(__FILE__)."/version.php");
		$this->MODULE_VERSION = $arModuleVersion["VERSION"];
		$this->MODULE_VERSION_DATE = $arModuleVersion["VERSION_DATE"];
		$this->MODULE_NAME = GetMessage("cocount21187.cocount21187_MODULE_NAME");
		$this->MODULE_DESCRIPTION = GetMessage("cocount21187.cocount21187_MODULE_DESC");

		$this->PARTNER_NAME = GetMessage("cocount21187.cocount21187_PARTNER_NAME");
		$this->PARTNER_URI = GetMessage("cocount21187.cocount21187_PARTNER_URI");

		$this->exclusionAdminFiles = array(
			'..',
			'.',
			'menu.php',
			'operation_description.php',
			'task_description.php'
		);
	}

	function InstallDB($arParams = array())
	{
		RegisterModuleDependences('main', 'OnBuildGlobalMenu', self::MODULE_ID, 'CCocountCocount', 'OnBuildGlobalMenu');
		return true;
	}

	function UnInstallDB($arParams = array())
	{
		UnRegisterModuleDependences('main', 'OnBuildGlobalMenu', self::MODULE_ID, 'CCocountCocount', 'OnBuildGlobalMenu');
		return true;
	}

	function InstallEvents()
	{
		return true;
	}

	function UnInstallEvents()
	{
		return true;
	}

	/*

	function InstallFiles($arParams = array())
	{
		if (is_dir($p = $_SERVER['DOCUMENT_ROOT'].'/bitrix/modules/'.self::MODULE_ID.'/admin'))
		{
			if ($dir = opendir($p))
			{
				while (false !== $item = readdir($dir))
				{
					if ($item == '..' || $item == '.' || $item == 'menu.php')
						continue;
					file_put_contents($file = $_SERVER['DOCUMENT_ROOT'].'/bitrix/admin/'.self::MODULE_ID.'_'.$item,
					'<'.'? require($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/'.self::MODULE_ID.'/admin/'.$item.'");?'.'>');
				}
				closedir($dir);
			}
		}
		if (is_dir($p = $_SERVER['DOCUMENT_ROOT'].'/bitrix/modules/'.self::MODULE_ID.'/install/components'))
		{
			if ($dir = opendir($p))
			{
				while (false !== $item = readdir($dir))
				{
					if ($item == '..' || $item == '.')
						continue;
					CopyDirFiles($p.'/'.$item, $_SERVER['DOCUMENT_ROOT'].'/bitrix/components/'.$item, $ReWrite = True, $Recursive = True);
				}
				closedir($dir);
			}
		}
		return true;
	}

	function UnInstallFiles()
	{
		if (is_dir($p = $_SERVER['DOCUMENT_ROOT'].'/bitrix/modules/'.self::MODULE_ID.'/admin'))
		{
			if ($dir = opendir($p))
			{
				while (false !== $item = readdir($dir))
				{
					if ($item == '..' || $item == '.')
						continue;
					unlink($_SERVER['DOCUMENT_ROOT'].'/bitrix/admin/'.self::MODULE_ID.'_'.$item);
				}
				closedir($dir);
			}
		}
		if (is_dir($p = $_SERVER['DOCUMENT_ROOT'].'/bitrix/modules/'.self::MODULE_ID.'/install/components'))
		{
			if ($dir = opendir($p))
			{
				while (false !== $item = readdir($dir))
				{
					if ($item == '..' || $item == '.' || !is_dir($p0 = $p.'/'.$item))
						continue;

					$dir0 = opendir($p0);
					while (false !== $item0 = readdir($dir0))
					{
						if ($item0 == '..' || $item0 == '.')
							continue;
						DeleteDirFilesEx('/bitrix/components/'.$item.'/'.$item0);
					}
					closedir($dir0);
				}
				closedir($dir);
			}
		}
		return true;
	}

	*/

	function DoInstall()
	{
		global $APPLICATION;
		if ($this->isVersionD7()){
			RegisterModule(self::MODULE_ID);
			$this->InstallFiles();
			$this->InstallDB();
			$this->installEvents();
		} else {
			$APPLICATION->ThrowException(GetMessage("cocount21187.cocount21187_INSTALL_ERROR_VERSION"));
		}

		$APPLICATION->IncludeAdminFile(Loc::getMessage('cocount21187.cocount21187_INSTALL_TITLE'), $this->GetPath() . '/install/step.php');

	}

	function DoUninstall()
	{
		global $APPLICATION;

		$context = Application::getInstance()->getContext();
		$request = $context->getRequest();

		if ($request['step'] < 2) {
			$APPLICATION->IncludeAdminFile(Loc::getMessage('cocount21187.cocount21187_INSTALL_TITLE'), $this->GetPath() . '/install/unstep1.php');
		} elseif($request['step'] == 2) {

			$this->UnInstallFiles();
			//$this->UnInstallEvents();

//			if ($request['savedata'] != 'Y') {
//				$this->UnInstallDB();
//			}

			UnRegisterModule(self::MODULE_ID);
			$APPLICATION->IncludeAdminFile(Loc::getMessage('cocount21187.cocount21187_INSTALL_TITLE'), $this->GetPath() . '/install/unstep2.php');
		}

	}

	// проверяем, что система поддерживает D7
	public function isVersionD7()
	{
		return CheckVersion(\Bitrix\Main\ModuleManager::getVersion('main'), '14.00.00');
	}

	// определяем место размещения модуля
	public function GetPath($notDocumentRoot = false)
	{
		if ($notDocumentRoot) {
			return str_ireplace(Application::getDocumentRoot(), '', dirname(__DIR__));
		} else {
			return dirname(__DIR__);
		}
	}


	public function InstallFiles($arParams = array())
	{
		$path = $this->GetPath().'/install/components';

//		echo '<pre>';
//		    print_r($path);
//		echo '<pre>';
//		exit();

		if (\Bitrix\Main\IO\Directory::isDirectoryExists($path)) {
			CopyDirFiles($this->GetPath().'/install/components', $_SERVER['DOCUMENT_ROOT'].'/bitrix/components', true, true);
		} else {
			throw new \Bitrix\Main\IO\InvalidPathException($path);
		}

		if (\Bitrix\Main\IO\Directory::isDirectoryExists($path = $this->GetPath() . '/admin'))
		{
			CopyDirFiles($this->GetPath() . '/install/admin/', $_SERVER['DOCUMENT_ROOT'] . '/bitrix/admin');
			if ($dir = opendir($path))
			{
				while (false !== $item = readdir($dir))
				{
					if (in_array($item, $this->exclusionAdminFiles))
						continue;
					file_put_contents($_SERVER['DOCUMENT_ROOT'].'/bitrix/admin/'.$this->MODULE_ID.'_'.$item, '<'. '? require ($_SERVER["DOCUMENT_ROOT."]."'.$this->GetPath(true).'/admin/'.$item.'");?'.'>');
				}
			}
			closedir($dir);
		}
	}


	public function UnInstallFiles($arParams = array())
	{
		\Bitrix\Main\IO\Directory::deleteDirectory($_SERVER['DOCUMENT_ROOT'] . '/bitrix/components/cocount21187/');

		if (\Bitrix\Main\IO\Directory::isDirectoryExists($path = $this->GetPath() . '/admin'))
		{
			DeleteDirFiles($_SERVER['DOCUMENT_ROOT'] . $this->GetPath() . '/install/admin', $_SERVER['DOCUMENT_ROOT'] . '/bitrix/admin');
			if ($dir = opendir($path)) {
				while (false !== $item = readdir($dir)) {
					if (in_array($item, $this->exclusionAdminFiles))
						continue;
					\Bitrix\Main\IO\File::deleteFile($_SERVER['DOCUMENT_ROOT'] . '/bitrix/admin' . $this->MODULE_ID . '_' . $item);
				}
				closedir($dir);
			}
		}
	}


	/*

	function InstallEvents()
	{
		\Bitrix\Main\EventManager::getInstance()->registerEventHandler($this->MODULE_ID, 'TestEventD7', '\Academy\D7\Event', 'eventHandler');
	}

	function UnInstallEvents()
	{
		\Bitrix\Main\EventManager::getInstance()->unRegisterEventHandler($this->MODULE_ID, 'TestEventD7', '\Academy\D7\Event', 'eventHandler');
	}

	*/

	function GetModuleRightList()
	{
		return array(
			'reference_id' => array('D', 'K', 'S', 'W'),
			'reference' => array(
				'[D] '.Loc::getMessage('cocount21187_D7_DENIED'),
				'[K] '.Loc::getMessage('cocount21187_D7_READ_COMPONENT'),
				'[S] '.Loc::getMessage('cocount21187_D7_WRITE_SETTINGS'),
				'[W] '.Loc::getMessage('cocount21187_D7_FULL')
			)
		);
	}




}
?>
